package DipGUI;

import java.awt.Color;
import java.io.IOException;
import java.util.List;
import java.util.Properties;
import javax.swing.JTextArea;
import javax.swing.UIManager;
import utility.DipUtils;

/**
 * Trida realizuje kompletni GUI programu, pres ktere se cela aplikace ovlada.
 * Parametry a jejich hodnoty jsou nacteny z diplomka.properties a tento soubor
 * i jeho umisteni je nedilnou soucasti alikace. Bez neho nebude aplikace fungovat!
 *
 * @deprecated Nahrazeno spoustenim bez GUI!
 */
@Deprecated
public class HlavniGUI extends javax.swing.JFrame {

    private int pocetCyklu = 0;
    private int pocetVektoru = 0;
    private String oznaceniAlgoritmu;
    
    private static Properties properties = null;

    private int pocetVysledku = 0;
    
    /**
     * Konstruktor tridy.
     *
     * @throws Exception
     */
    public HlavniGUI() throws Exception {
        properties = DipUtils.nactiProperties();
        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        initComponents();        
        oznaceniAlgoritmuLabel.setText(properties.getProperty("oznaceni.algoritmu"));
        generujButton.setVisible(false);
        
        vygenerujTestData();
        Thread.sleep(500);
        oznaceniAlgoritmu = properties.getProperty("oznaceni.algoritmu");       
        aktualizujHodnoty();

        
    /**
     * Trida zajistuje cyklicke opakovani algoritmu LZPR.
     * 1. Vygeneruje sekvenci LZPR testovacich vektoru.
     * 2. Sadu testovacich vektoru vlozi Atalante a vyhodnoti, kolik
     *      kolik detekovaly poruch.
     * 3. Pokud byly detekovany vsechny poruchy, jsou zobrazeny vysledky,
     *      vygeneruje se novy polynom i seed a pokracuje se bodem 1.,
     *      jinak se zvysi pocet testovacich vektoru a opakuje se bod 2.
     * 4. Cela sekvence bodu 1., 2. a 3. se opakuje n-krat, pro n pozadovanych testu.
     */
    class AutomatizaceLZPR extends Thread {
        @Override
        public void run() {           
            vymazSouborAction(null);
            int detekovatelnychPoruch = Integer.valueOf(properties.getProperty("detekovatelnych.poruch"));
            try {
                DipUtils.nactiVysledkyAtalanty(true);
                vymazSouborAction(null);
                while (Integer.valueOf(DipUtils.getAktPocetDetekPoruch()) < detekovatelnychPoruch ) {
                    System.out.println("Aktualne detek: " + DipUtils.getAktPocetDetekPoruch());
                    DipUtils.vyprazdniSoubor(vystupSouborField.getText());
//                    wrapper.spustLZPRAlgoritmus(polynomField.getText(), seedField.getText(),
//                            vystupSouborField.getText(), oznaceniObvoduField.getText(),
//                            spustitAtalantuCheckBox.isSelected());
                    DipUtils.nactiVysledkyAtalanty(true);
                    zobrazVysledky();
                    zvysPocetVektoruAction(null);
                    vymazSouborAction(null);
                }
                zobrazVysledky();
                zapisButtonAction(null);
                pocetVysledku++;
                System.out.println("Aktualizuju!!!");
                DipUtils.nastavPocDetekP = false;
                //vygenerujTestData();
                //DipUtils.nactiVysledkyAtalanty(true);
                aktualizujHodnotyAction(null);
                Thread.sleep(1000);
                if (pocetVysledku < Integer.valueOf(properties.getProperty("pocet.vysledku"))) {
                    //toto je variabilni, lze menit seed a(nebo) polynom, nebo nechat oboje fixni, ...
                    generujSeedAction(null);
                    generujPolynomAction(null);
                    spustAlgoritmusAction(null);
                }
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
    }
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        nadpisLabel = new javax.swing.JLabel();
        algoritmusPanel = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        sablonaPanel = new javax.swing.JPanel();
        polynomLabel = new javax.swing.JLabel();
        polynomField = new javax.swing.JTextField();
        seedLabel = new javax.swing.JLabel();
        seedField = new javax.swing.JTextField();
        generujPolynomButton = new javax.swing.JButton();
        generujSeedButton = new javax.swing.JButton();
        dalsiParametryPanel = new javax.swing.JPanel();
        pocetVektoruCykluLabel = new javax.swing.JLabel();
        pocetVektoruField = new javax.swing.JTextField();
        oznaceniObvoduLabel = new javax.swing.JLabel();
        oznaceniObvoduField = new javax.swing.JTextField();
        benchSouborLabel = new javax.swing.JLabel();
        benchSouborField = new javax.swing.JTextField();
        souborTestSekvLabel = new javax.swing.JLabel();
        vystupSouborField = new javax.swing.JTextField();
        spustitAtalantuLabel = new javax.swing.JLabel();
        spustitAtalantuCheckBox = new javax.swing.JCheckBox();
        reloadButton = new javax.swing.JButton();
        souborNedetPoruchyLabel = new javax.swing.JLabel();
        souborNedetPoruchyField = new javax.swing.JTextField();
        spustButton = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        atalantaArea = new javax.swing.JTextArea();
        cyklyVektoryLabel = new javax.swing.JLabel();
        cyklyVektoryField = new javax.swing.JTextField();
        generujButton = new javax.swing.JButton();
        detekPoruchLabel = new javax.swing.JLabel();
        detekPoruchField = new javax.swing.JTextField();
        vymazSouborButton = new javax.swing.JButton();
        zapisButton = new javax.swing.JButton();
        oznaceniAlgoritmuLabel = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setName("hlavniFrame"); // NOI18N
        setResizable(false);

        nadpisLabel.setFont(new java.awt.Font("Tahoma", 1, 14));
        nadpisLabel.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        nadpisLabel.setText("Návrh generátoru pseudonáhodných vektorů pro vestavěnou diagnostiku");

        algoritmusPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Parametry algoritmu", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 12))); // NOI18N

        polynomLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        polynomLabel.setText("Polynom:");

        polynomField.setEditable(false);

        seedLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        seedLabel.setText("Seed:");

        seedField.setEditable(false);

        generujPolynomButton.setFont(new java.awt.Font("Tahoma", 0, 8));
        generujPolynomButton.setText("G");
        generujPolynomButton.setIconTextGap(2);
        generujPolynomButton.setMargin(new java.awt.Insets(1, 3, 1, 3));
        generujPolynomButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                generujPolynomAction(evt);
            }
        });

        generujSeedButton.setFont(new java.awt.Font("Tahoma", 0, 8));
        generujSeedButton.setText("G");
        generujSeedButton.setIconTextGap(2);
        generujSeedButton.setMargin(new java.awt.Insets(1, 3, 1, 3));
        generujSeedButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                generujSeedAction(evt);
            }
        });

        dalsiParametryPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Další parametry algoritmu"));

        pocetVektoruCykluLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        pocetVektoruCykluLabel.setText("Počet vektorů cyklu:");

        pocetVektoruField.setEditable(false);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("main/diplomka"); // NOI18N
        pocetVektoruField.setText(bundle.getString("maximalni.pocet.vektoru")); // NOI18N
        pocetVektoruField.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                zvysPocetVektoruAction(evt);
            }
        });

        oznaceniObvoduLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        oznaceniObvoduLabel.setText("Označení obvodu:");

        oznaceniObvoduField.setText(bundle.getString("oznaceni.obvodu")); // NOI18N
        oznaceniObvoduField.setEnabled(false);

        benchSouborLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        benchSouborLabel.setText("Bench soubor:");

        benchSouborField.setText(bundle.getString("soubor.bench")); // NOI18N
        benchSouborField.setEnabled(false);

        souborTestSekvLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        souborTestSekvLabel.setText("Soubor test. sekv.:");

        vystupSouborField.setText(bundle.getString("soubor.atalanta.pat")); // NOI18N
        vystupSouborField.setEnabled(false);

        spustitAtalantuLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        spustitAtalantuLabel.setText("Spustit Atalantu:");

        spustitAtalantuCheckBox.setSelected(true);

        reloadButton.setFont(new java.awt.Font("Tahoma", 1, 11));
        reloadButton.setText("Reload konfig. soubor");
        reloadButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                aktualizujHodnotyAction(evt);
            }
        });

        souborNedetPoruchyLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        souborNedetPoruchyLabel.setText("Soubor nedet. poruchy:");

        souborNedetPoruchyField.setText(bundle.getString("soubor.nedetekovane.poruchy")); // NOI18N
        souborNedetPoruchyField.setEnabled(false);

        spustButton.setFont(new java.awt.Font("Tahoma", 1, 11));
        spustButton.setText("RUN");
        spustButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                spustAlgoritmusAction(evt);
            }
        });

        atalantaArea.setColumns(20);
        atalantaArea.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        atalantaArea.setRows(5);
        atalantaArea.setEnabled(false);
        jScrollPane1.setViewportView(atalantaArea);

        cyklyVektoryLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        cyklyVektoryLabel.setText("#cyklů / #vektorů:");

        cyklyVektoryField.setEditable(false);
        cyklyVektoryField.setText(bundle.getString("soubor.pro.vystup.nedetek.poruchy")); // NOI18N
        cyklyVektoryField.setEnabled(false);

        generujButton.setFont(new java.awt.Font("Tahoma", 1, 11));
        generujButton.setText("Generuj");
        generujButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                generujTestovaciVektoryAction(evt);
            }
        });

        detekPoruchLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        detekPoruchLabel.setText("#detek. poruch:");

        detekPoruchField.setEditable(false);
        detekPoruchField.setEnabled(false);

        vymazSouborButton.setFont(new java.awt.Font("Tahoma", 1, 11));
        vymazSouborButton.setText("Vymaz!");
        vymazSouborButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                vymazSouborAction(evt);
            }
        });

        zapisButton.setFont(new java.awt.Font("Tahoma", 1, 11));
        zapisButton.setText("Zapis");
        zapisButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                zapisButtonAction(evt);
            }
        });

        javax.swing.GroupLayout dalsiParametryPanelLayout = new javax.swing.GroupLayout(dalsiParametryPanel);
        dalsiParametryPanel.setLayout(dalsiParametryPanelLayout);
        dalsiParametryPanelLayout.setHorizontalGroup(
            dalsiParametryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(dalsiParametryPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(dalsiParametryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(pocetVektoruCykluLabel)
                    .addComponent(oznaceniObvoduLabel)
                    .addComponent(benchSouborLabel)
                    .addComponent(souborTestSekvLabel)
                    .addComponent(souborNedetPoruchyLabel)
                    .addComponent(spustitAtalantuLabel)
                    .addComponent(cyklyVektoryLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(dalsiParametryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(pocetVektoruField)
                    .addComponent(oznaceniObvoduField, javax.swing.GroupLayout.DEFAULT_SIZE, 69, Short.MAX_VALUE)
                    .addComponent(souborNedetPoruchyField, 0, 0, Short.MAX_VALUE)
                    .addComponent(benchSouborField)
                    .addComponent(vystupSouborField, javax.swing.GroupLayout.DEFAULT_SIZE, 283, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, dalsiParametryPanelLayout.createSequentialGroup()
                        .addGroup(dalsiParametryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(dalsiParametryPanelLayout.createSequentialGroup()
                                .addComponent(spustitAtalantuCheckBox)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(zapisButton))
                            .addComponent(cyklyVektoryField, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 57, Short.MAX_VALUE)
                        .addGroup(dalsiParametryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(dalsiParametryPanelLayout.createSequentialGroup()
                                .addComponent(detekPoruchLabel)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(detekPoruchField))
                            .addComponent(reloadButton))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(dalsiParametryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(dalsiParametryPanelLayout.createSequentialGroup()
                        .addComponent(generujButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 77, Short.MAX_VALUE)
                        .addComponent(vymazSouborButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(spustButton))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 294, Short.MAX_VALUE))
                .addContainerGap())
        );
        dalsiParametryPanelLayout.setVerticalGroup(
            dalsiParametryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(dalsiParametryPanelLayout.createSequentialGroup()
                .addGroup(dalsiParametryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(dalsiParametryPanelLayout.createSequentialGroup()
                        .addGroup(dalsiParametryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(pocetVektoruCykluLabel)
                            .addComponent(pocetVektoruField, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(dalsiParametryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(oznaceniObvoduLabel)
                            .addComponent(oznaceniObvoduField, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(dalsiParametryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(benchSouborLabel)
                            .addComponent(benchSouborField, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(dalsiParametryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(vystupSouborField, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(souborTestSekvLabel))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(dalsiParametryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(souborNedetPoruchyLabel)
                            .addComponent(souborNedetPoruchyField, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(dalsiParametryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(cyklyVektoryLabel)
                            .addComponent(cyklyVektoryField, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(detekPoruchLabel)
                            .addComponent(detekPoruchField, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 158, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(dalsiParametryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(spustitAtalantuLabel)
                    .addComponent(spustitAtalantuCheckBox)
                    .addGroup(dalsiParametryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(reloadButton)
                        .addComponent(spustButton)
                        .addComponent(generujButton)
                        .addComponent(vymazSouborButton)
                        .addComponent(zapisButton)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout sablonaPanelLayout = new javax.swing.GroupLayout(sablonaPanel);
        sablonaPanel.setLayout(sablonaPanelLayout);
        sablonaPanelLayout.setHorizontalGroup(
            sablonaPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, sablonaPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(sablonaPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(dalsiParametryPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(sablonaPanelLayout.createSequentialGroup()
                        .addGroup(sablonaPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(polynomLabel)
                            .addComponent(seedLabel))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(sablonaPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(seedField, javax.swing.GroupLayout.DEFAULT_SIZE, 680, Short.MAX_VALUE)
                            .addComponent(polynomField, javax.swing.GroupLayout.DEFAULT_SIZE, 680, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(sablonaPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(generujSeedButton, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(generujPolynomButton, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );
        sablonaPanelLayout.setVerticalGroup(
            sablonaPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(sablonaPanelLayout.createSequentialGroup()
                .addGap(22, 22, 22)
                .addGroup(sablonaPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(polynomLabel)
                    .addComponent(polynomField, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(generujPolynomButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(sablonaPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(seedLabel)
                    .addComponent(seedField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(generujSeedButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(dalsiParametryPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(sablonaPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addComponent(sablonaPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(62, 62, 62))
        );

        oznaceniAlgoritmuLabel.setFont(new java.awt.Font("Tahoma", 1, 12));
        oznaceniAlgoritmuLabel.setText("LZPR");
        oznaceniAlgoritmuLabel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        javax.swing.GroupLayout algoritmusPanelLayout = new javax.swing.GroupLayout(algoritmusPanel);
        algoritmusPanel.setLayout(algoritmusPanelLayout);
        algoritmusPanelLayout.setHorizontalGroup(
            algoritmusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(algoritmusPanelLayout.createSequentialGroup()
                .addGap(322, 322, 322)
                .addComponent(oznaceniAlgoritmuLabel)
                .addContainerGap(459, Short.MAX_VALUE))
            .addGroup(algoritmusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(algoritmusPanelLayout.createSequentialGroup()
                    .addGap(9, 9, 9)
                    .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );
        algoritmusPanelLayout.setVerticalGroup(
            algoritmusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(algoritmusPanelLayout.createSequentialGroup()
                .addComponent(oznaceniAlgoritmuLabel)
                .addContainerGap(321, Short.MAX_VALUE))
            .addGroup(algoritmusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(algoritmusPanelLayout.createSequentialGroup()
                    .addGap(21, 21, 21)
                    .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 315, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );

        oznaceniAlgoritmuLabel.getAccessibleContext().setAccessibleName("algoritmusLabel");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(125, 125, 125)
                        .addComponent(nadpisLabel))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(19, 19, 19)
                        .addComponent(algoritmusPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(nadpisLabel)
                .addGap(18, 18, 18)
                .addComponent(algoritmusPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 360, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void generujPolynomAction(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_generujPolynomAction
        try {
            String polynText = DipUtils.generujPolynom(Integer.valueOf(properties.getProperty("stupen.polynomu")));
            polynomField.setText(polynText);
            DipUtils.vyprazdniSoubor(vystupSouborField.getText());
            Thread.sleep(250);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }//GEN-LAST:event_generujPolynomAction

    private void generujSeedAction(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_generujSeedAction
        try {
            String seedText = DipUtils.generujSeed(Integer.valueOf(properties.getProperty("stupen.polynomu")));
            seedField.setText(seedText);
            DipUtils.vyprazdniSoubor(vystupSouborField.getText());
            Thread.sleep(250);
        } catch (Exception ex) {
            ex.printStackTrace();
        }        
    }//GEN-LAST:event_generujSeedAction

    private void generujTestovaciVektoryAction(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_generujTestovaciVektoryAction
       //TODO
    }//GEN-LAST:event_generujTestovaciVektoryAction

    private void aktualizujHodnotyAction(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_aktualizujHodnotyAction
        try {
            aktualizujHodnoty();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }//GEN-LAST:event_aktualizujHodnotyAction

    private void spustAlgoritmusAction(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_spustAlgoritmusAction
        //spustButton.setEnabled(false);
        pocetCyklu++;
        pocetVektoru += Integer.valueOf(properties.getProperty("maximalni.pocet.vektoru"));
        aktualizujPCykluAVektoru();

        try {
            //Spousti se algoritmus zakladniho LZPR.            
            if (oznaceniAlgoritmu.equalsIgnoreCase("LZPR")) {
                AutomatizaceLZPR alzpr = new AutomatizaceLZPR();
                alzpr.start();
            } 
            //Spousti se algorimus jednopolynomialniho reseedingu.
            else if (oznaceniAlgoritmu.equalsIgnoreCase("JPOR")) {
                AutomatizaceJPOR ajpor = new AutomatizaceJPOR();
                ajpor.start();
            }
            else if (oznaceniAlgoritmu.equalsIgnoreCase("AJPOR")) {
                AutomatizaceAJPOR aajpor = new AutomatizaceAJPOR();
                aajpor.start();
            }
            //Spusti se algoritmus folding counter.
            else if (oznaceniAlgoritmu.equalsIgnoreCase("FCOU")) {
              throw new Exception(properties.getProperty("param.error"));
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }//GEN-LAST:event_spustAlgoritmusAction

    private void vymazSouborAction(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_vymazSouborAction
        try {            
            DipUtils.vyprazdniSoubor(vystupSouborField.getText());
            Thread.sleep(250);
            DipUtils.vyprazdniSoubor(properties.getProperty("soubor.atalanta.rep"));  
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        vymazSouborButton.setForeground(Color.BLACK);
    }//GEN-LAST:event_vymazSouborAction

    private void zapisButtonAction(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_zapisButtonAction
        try {
            DipUtils.zapisPocetNutnychVektoru(pocetVektoruField.getText(), "NULL");
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }//GEN-LAST:event_zapisButtonAction

    private void zvysPocetVektoruAction(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_zvysPocetVektoruAction
        int aktPocetVektoru = Integer.valueOf(pocetVektoruField.getText());
        aktPocetVektoru += Integer.valueOf(properties.getProperty("zvysovat.pocet.vektoru"));
        pocetVektoruField.setText(String.valueOf(aktPocetVektoru));
        properties.setProperty("maximalni.pocet.vektoru", pocetVektoruField.getText());
        System.out.println("Zvysuju pocet vektoru na " + aktPocetVektoru + " / " + pocetVektoruField.getText());        
    }//GEN-LAST:event_zvysPocetVektoruAction

    /**
     * Metoda vygeneruje testovaci vektory a zapise je do souboru.
     */
    private void vygenerujTestData() {        
        try {
            DipUtils.spustExternal(oznaceniObvoduField.getText(),
                    properties.getProperty("generuj.testovaci.vektory.bat"));
            Thread.sleep(3000);
            DipUtils.nactiVysledkyAtalanty(true);
            detekPoruchField.setText(DipUtils.getMaxPocetDetekovatPoruch());
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    /**
     * Metoda aktualizuje hodnoty v polickach i data v souborech dle zvoleneho
     * algoritmu.
     *
     * @throws Exception
     */
    public void aktualizujHodnoty() throws Exception {
        properties = DipUtils.nactiProperties();        
        if (pocetCyklu < 1) {
            detekPoruchField.setText(DipUtils.getMaxPocetDetekovatPoruch());
        } else {
            properties = DipUtils.nactiProperties();
        }
        pocetVektoruField.setText(properties.getProperty("maximalni.pocet.vektoru"));
        oznaceniObvoduField.setText(properties.getProperty("oznaceni.obvodu"));
        benchSouborField.setText(properties.getProperty("soubor.bench"));
        vystupSouborField.setText(properties.getProperty("soubor.atalanta.pat"));
        souborNedetPoruchyField.setText(properties.getProperty("soubor.nedetekovane.poruchy"));
        //polynomField.setText(properties.getProperty("polynom"));
        pocetCyklu = 0;
        pocetVektoru = 0;
        DipUtils.setAktPocetDetekPoruch("0");
        zobrazVysledky();
        aktualizujPCykluAVektoru();
    }

    /**
     * Metoda aktualizuje hodnoty ve vybranych polickach.
     */
    public void aktualizujPCykluAVektoru() {
        cyklyVektoryField.setText(pocetCyklu + " / " + pocetVektoru);
    }
    
    /**
     * Metoda zobrazi v GUI vysledky Atalanty.
     *
     * @throws IOException
     */
    private void zobrazVysledky() throws Exception {
        atalantaArea.setText("");
        List<String> vysledkyAtalanty = DipUtils.nactiVysledkyAtalanty(false);
        for (String vysledek : vysledkyAtalanty) {
            atalantaArea.append(vysledek);
            atalantaArea.append("\n");
        }      
    }
    
    /**
     * 
     * @param args - parametry prikazove radky
     * @throws Exception
     */
    public static void main(final String args[]) throws Exception {
        java.awt.EventQueue.invokeLater(new Runnable() {

            @Override
            public void run() {
                try {
                    new HlavniGUI().setVisible(true);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        });
    }

    /**
     * Trida zajistuje cyklicke opakovani algoritmu LZPR.
     * 1. Vygeneruje sekvenci LZPR testovacich vektoru.
     * 2. Sadu testovacich vektoru vlozi Atalante a vyhodnoti, kolik
     *      kolik detekovaly poruch.
     * 3. Pokud byly detekovany vsechny poruchy, jsou zobrazeny vysledky,
     *      vygeneruje se novy polynom i seed a pokracuje se bodem 1.,
     *      jinak se zvysi pocet testovacich vektoru a opakuje se bod 2.
     * 4. Cela sekvence bodu 1., 2. a 3. se opakuje n-krat, pro n pozadovanych testu.
     */
    class AutomatizaceLZPR extends Thread {
        @Override
        public void run() {
            try {
                DipUtils.nactiVysledkyAtalanty(true);
            } catch (Exception ex) {
                ex.printStackTrace();
            }
            int detekovatelnychPoruch = Integer.valueOf(properties.getProperty("detekovatelnych.poruch"));
            vymazSouborAction(null);
            try {                
                while (Integer.valueOf(DipUtils.getAktPocetDetekPoruch()) < detekovatelnychPoruch ) {
                    System.out.println("Aktualne detek: " + DipUtils.getAktPocetDetekPoruch());
                    DipUtils.vyprazdniSoubor(vystupSouborField.getText());
//                    wrapper.spustLZPRAlgoritmus(polynomField.getText(), seedField.getText(),
//                            vystupSouborField.getText(), oznaceniObvoduField.getText(),
//                            spustitAtalantuCheckBox.isSelected());
                    DipUtils.nactiVysledkyAtalanty(true);
                    zobrazVysledky();                    
                    zvysPocetVektoruAction(null);                   
                    vymazSouborAction(null);
                }               
                zobrazVysledky();
                zapisButtonAction(null);
                pocetVysledku++;
                System.out.println("Aktualizuju!!!");
                DipUtils.nastavPocDetekP = false;
                //vygenerujTestData();
                //DipUtils.nactiVysledkyAtalanty(true);
                aktualizujHodnotyAction(null);               
                if (pocetVysledku < Integer.valueOf(properties.getProperty("pocet.vysledku"))) {
                    //toto je variabilni, lze menit seed a(nebo) polynom, nebo nechat oboje fixni, ...
                    generujSeedAction(null);
                    generujPolynomAction(null);
                    spustAlgoritmusAction(null);
                }
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
    }

    class AutomatizaceJPOR extends Thread {
        private boolean mamVektor = true;
        @Override
        public void run() {           
            try {
                while(mamVektor) {
//                    wrapper.spustReseedingJednoPol(polynomField.getText(), seedField.getText(),
//                            vystupSouborField.getText(), oznaceniObvoduField.getText(),
//                            spustitAtalantuCheckBox.isSelected());
//                    AutomatizaceJPOR.sleep(250);
                    String vektorZbyvajiciPorucha =
                            DipUtils.nactiRadekDat(properties.getProperty("soubor.nedetekovane.poruchy"));
                    if (vektorZbyvajiciPorucha == null || vektorZbyvajiciPorucha.equals("")) {
                        mamVektor = false;
                    }
                    seedField.setText(vektorZbyvajiciPorucha);
                    pocetCyklu ++;
                    Thread.sleep(250);
                    zobrazVysledky();
                    pocetVektoru = pocetCyklu * Integer.valueOf(properties.getProperty("maximalni.pocet.vektoru"));
                    pocetVektoruField.setText(String.valueOf(pocetVektoru));
                    aktualizujPCykluAVektoru();
                }               
                pocetVysledku++;
                zapisButtonAction(null);
                Thread.sleep(500);
                vymazSouborAction(null);
                aktualizujHodnoty();
                if (pocetVysledku < Integer.valueOf(properties.getProperty("pocet.vysledku"))) {
                    //toto je variabilni, lze menit seed a(nebo) polynom, nebo nechat oboje fixni, ...
                    generujSeedAction(null);
                    generujPolynomAction(null);
                    spustAlgoritmusAction(null);
                }
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
    }

    class AutomatizaceAJPOR extends Thread {
        final double konstanta = 0.1;
        @Override
        public void run() {                     
            vymazSouborAction(null);            
            int aktDetekPoruch = 0;
            //pocet poruch na zacatku mereneho useku iteraci
            int vychoziPocetDetPoruch = 0;
            int initPocetIteraci = Integer.valueOf(properties.getProperty("init.pocet.iteraci"));
            int ccaPocetIteraci = initPocetIteraci;
            int dilciPocetIter = 0;

            try {
                DipUtils.vyprazdniSoubor(properties.getProperty("soubor.detekovane.poruchy"));
                String testVektor = seedField.getText();
                DipUtils.setPocetAktDetekovatPoruch("0");
                
                while (!String.valueOf(aktDetekPoruch).equals(DipUtils.getMaxPocetDetekovatPoruch())) {
                    //na zacatku kazdeho useku iteraci nastavim vychozi pocet detekovanych poruch
                    if (vychoziPocetDetPoruch == 0) {
                        vychoziPocetDetPoruch = Integer.valueOf(DipUtils.getAktPocetDetekPoruch());
                    }
                    
                    DipUtils.zapisVektoryDoSouboru(vystupSouborField.getText(), testVektor, true);
                    Thread.sleep(50);
                    DipUtils.spustExternal(properties.getProperty("oznaceni.obvodu"),
                            properties.getProperty("lzpr.soubor.bat"));
                    zobrazVysledky();

                    Thread.sleep(50);
                    DipUtils.zapisPocetDetekDoSouboru(DipUtils.getAktPocetDetekPoruch());
                    testVektor  = DipUtils.krokLZPR(polynomField.getText(), testVektor);
                    aktDetekPoruch = Integer.valueOf(DipUtils.getAktPocetDetekPoruch());
                    dilciPocetIter++;                                       
                   
                    if (dilciPocetIter == Math.round(ccaPocetIteraci * konstanta)) {
                        if ((aktDetekPoruch-vychoziPocetDetPoruch) < Math.round(aktDetekPoruch * konstanta)) {
                            //bude reseding
                            System.out.println("Reseeding: " + "Akt. - vych.: " + (aktDetekPoruch-vychoziPocetDetPoruch)
                                    + " akt: " + aktDetekPoruch  + "  vychoz: " + vychoziPocetDetPoruch);
                            System.out.println("Dilci iter.: " + dilciPocetIter + " cca: " + ccaPocetIteraci +
                                    "  cca zaokr.: " + Math.round(ccaPocetIteraci * konstanta));
//                            wrapper.spustAdaptReseedJednoPol();
                            String vektorReseedingu =
                                DipUtils.nactiRadekDat(properties.getProperty("soubor.nedetekovane.poruchy"));
                            seedField.setText(vektorReseedingu);
                            //pokud se jedna o posledni vektor, delej jen kroky LZPR dokud nedetekujes zbyvajci poruchy
//                            if (DipUtils.getPocetVektoruVSouboru(properties.getProperty("soubor.nedetekovane.poruchy")) < 2) {
//                                System.out.println("Jeden posledni vektor!");
//                                while (!String.valueOf(aktDetekPoruch).equals(DipUtils.getMaxPocetDetekovatPoruch())) {
//                                    DipUtils.zapisVektoryDoSouboru(vystupSouborField.getText(), testVektor, true);
//                                    Thread.sleep(50);
//                                    DipUtils.spustExternal(properties.getProperty("oznaceni.obvodu"),
//                                            properties.getProperty("lzpr.soubor.bat"));
//                                    zobrazVysledky();
//                                    Thread.sleep(50);
//                                    DipUtils.zapisPocetDetekDoSouboru(DipUtils.getAktPocetDetekPoruch());
//                                    testVektor  = DipUtils.krokLZPR(polynomField.getText(), testVektor);
//                                    aktDetekPoruch = Integer.valueOf(DipUtils.getAktPocetDetekPoruch());
//                                }
//                            }
                            
                        } else {
                            //Jinak dalsi LZPR krok.
                        }
                        ccaPocetIteraci += dilciPocetIter;
                        dilciPocetIter = 0;
                        vychoziPocetDetPoruch = 0;
                    }                    
                }
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
    }   

    public static JTextArea getAtalantaArea() {
        return atalantaArea;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel algoritmusPanel;
    public static javax.swing.JTextArea atalantaArea;
    private javax.swing.JTextField benchSouborField;
    private javax.swing.JLabel benchSouborLabel;
    private javax.swing.JTextField cyklyVektoryField;
    private javax.swing.JLabel cyklyVektoryLabel;
    private javax.swing.JPanel dalsiParametryPanel;
    private javax.swing.JTextField detekPoruchField;
    private javax.swing.JLabel detekPoruchLabel;
    private javax.swing.JButton generujButton;
    private javax.swing.JButton generujPolynomButton;
    private javax.swing.JButton generujSeedButton;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel nadpisLabel;
    private javax.swing.JLabel oznaceniAlgoritmuLabel;
    private javax.swing.JTextField oznaceniObvoduField;
    private javax.swing.JLabel oznaceniObvoduLabel;
    private javax.swing.JLabel pocetVektoruCykluLabel;
    private javax.swing.JTextField pocetVektoruField;
    private javax.swing.JTextField polynomField;
    private javax.swing.JLabel polynomLabel;
    private javax.swing.JButton reloadButton;
    private javax.swing.JPanel sablonaPanel;
    private javax.swing.JTextField seedField;
    private javax.swing.JLabel seedLabel;
    private javax.swing.JTextField souborNedetPoruchyField;
    private javax.swing.JLabel souborNedetPoruchyLabel;
    private javax.swing.JLabel souborTestSekvLabel;
    private javax.swing.JButton spustButton;
    private javax.swing.JCheckBox spustitAtalantuCheckBox;
    private javax.swing.JLabel spustitAtalantuLabel;
    private javax.swing.JButton vymazSouborButton;
    private javax.swing.JTextField vystupSouborField;
    private javax.swing.JButton zapisButton;
    // End of variables declaration//GEN-END:variables
}
