package utility;

/**
 * Metody teto tridy zajistuji validace vstupnich hodnot.
 */
public class DipValidators {

    /**
     * Metoda otestuje, zda je polynom validni a vysledek testu vrati.
     *
     * @param polynom
     * @return true/false
     */
    public static final boolean jePolynomValidni(String polynom) {
        if (polynom == null || polynom.length() == 0 || polynom.equals("")) {            
            return false;
        }

        if (!polynom.startsWith("1")) {
            return false;
        }

        if (!polynom.endsWith("1")) {
            return false;
        }
        
        return true;
    }

    /**
     * Metoda otestuje, zda je param validni a vysledek testu vrati.
     *
     * @param param
     * @return true/false
     */
    public static final boolean jeParametrValidni(String param) {
        if (param == null || param.length() == 0 || param.equals("")) {
            return false;
        }

        return true;
    }

    /**
     * Metoda otestuje, zda je seed validni a vysledek testu vrati.
     *
     * @param seed
     * @return true/false
     */
    public static final boolean jeSeedValidni(String seed) {
        return jeParametrValidni(seed);
    }


    /**
     * Metoda kompletne zvaliduje jak polynom, tak i seed. Validace se provadi i mezi
     * polynomem a seedem. Vysledek validace je vracen.
     *
     * @param polynom
     * @param seed
     * @return vysledek validace
     */
    public static final boolean jePolynASeedValidni(String polynom, String seed) {
        return (jePolynomValidni(polynom) && jeSeedValidni(seed) && (polynom.length() == seed.length()));
    }
}
